#from typing_extensions import Required
from rest_framework import serializers
from brsessionApp.models import PatientSessionItem,PatientSession,PtSsnPayment,Session,PtSsnDebt
from brvisitApp.models import PatientVisit,PvDebt

# class PtSsnDebtMiniSerializer(serializers.ModelSerializer):
#     class Meta:
#         model = PtSsnDebt
#         fields = ['id','pt_ssn', 'notes']

class PtSsnDebtSerializer(serializers.ModelSerializer):
    class Meta:
        model = PtSsnDebt
        fields = ['notes']
        #fields = ['id', 'notes', 'updated_by', 'updated_at']

class PtSsnDebtMiniSerializer(serializers.ModelSerializer):
    contacted_at = serializers.DateTimeField(source="updated_at",format="%Y-%m-%d %I:%M %p",read_only=True)
    contact_emp_name = serializers.CharField(source="updated_by.name",read_only=True)
    class Meta:
        model = PtSsnDebt
        fields = ['id', 'notes', 'contact_emp_name', 'contacted_at']

class PatientSessionForDebtSerializer(serializers.ModelSerializer):
    pt_fullname = serializers.CharField(source='patient.fullname',read_only=True)
    pt_number_1 = serializers.CharField(source='patient.number_1',read_only=True)
    created_at = serializers.DateTimeField(format="%Y-%m-%d",read_only=True)
    s_name = serializers.CharField(source='session.name',read_only=True)
    pt_ssn_debt = PtSsnDebtMiniSerializer(read_only=True)
    class Meta:
        model = PatientSession
        fields=["id","patient","pt_fullname","pt_number_1","created_at","s_name","sessions_count","sessions_count_original","is_package","pt_ssn_debt",
                "sessions_count","sessions_done","sessions_absence","sessions_remain","amount_remaining","related_payment"]

class PsMiniForDebtSerializer(serializers.ModelSerializer):
    created_by_name = serializers.CharField(source="created_by.name",default="",read_only=True)
    pt_ssn_debt = PtSsnDebtMiniSerializer(read_only=True)
    total_cost = serializers.IntegerField(source="sessions_cost")
    class Meta:
        model = PatientSession
        fields=["id","total_cost","doctor_discount","amount_required","initial_payment","related_payment","amount_paid","amount_remaining","pt_ssn_debt",'created_by_name']

class PvDebtSerializer(serializers.ModelSerializer):
    class Meta:
        model = PvDebt
        fields = ['notes']
        #fields = ['id', 'notes', 'updated_by', 'updated_at']

class PvDebtMiniSerializer(serializers.ModelSerializer):
    contacted_at = serializers.DateTimeField(source="updated_at",format="%Y-%m-%d %I:%M %p",read_only=True)
    contact_emp_name = serializers.CharField(source="updated_by.name",read_only=True)
    class Meta:
        model = PvDebt
        fields = ['id', 'notes', 'contact_emp_name', 'contacted_at']


class PvForDebtSerializer(serializers.ModelSerializer):
    pt_fullname = serializers.CharField(source='patient.fullname',read_only=True)
    pt_number_1 = serializers.CharField(source='patient.number_1',read_only=True)
    created_at = serializers.DateTimeField(format="%Y-%m-%d",read_only=True)
    ms_name = serializers.CharField(source='medicalservice.name',read_only=True)
    pv_debt = PvDebtMiniSerializer(read_only=True)
    class Meta:
        model = PatientVisit
        fields=["id","patient","pt_fullname","pt_number_1","created_at","ms_name","pv_debt","amount_remaining","related_payment"]

class PvMiniForDebtSerializer(serializers.ModelSerializer):
    created_by_name = serializers.CharField(source="created_by.name",default="",read_only=True)
    total_cost = serializers.IntegerField(source="ms_cost")
    pv_debt = PvDebtMiniSerializer(read_only=True)
    class Meta:
        model = PatientVisit
        fields=["id","total_cost","doctor_discount","amount_required","related_payment","amount_paid","amount_remaining","pv_debt",'created_by_name']

